#%% Import packages
from rapidfuzz.process import extract # The fizz, the fuzz, the fizzyfuzz
from rapidfuzz.distance import DamerauLevenshtein
# from rapidfuzz.fuzz import ratio
import unicodedata # Yeah ya betcha baby
# from unidecode import unidecode
import regex # regex duh
import csv
# import string
from joblib import Parallel, delayed
import pandas as pd
from Bio.Align import PairwiseAligner
aligner = PairwiseAligner(mode='global', match_score=2, mismatch_score=-1)
aligner.mode = 'global'
# import pyarrow.parquet as pq
# import numpy as np
# import pyarrow as pa
import datetime
#
#%% Define read CSV function
def read_csv(filepath: str):
  data = []
  with open(filepath, 'r') as f:
    reader = csv.reader(f, delimiter=',')
    for row in reader:
      data.append(row)
  return data
#
#%% Convert test to standard unicode
# Not necessary for Buster. Already in UTF-8 but will check for accents in the
# author & vernacular data
def strip_accents(s):
 return ''.join(c for c in unicodedata.normalize('NFD', s) if unicodedata.category(c) != 'Mn')
#
# def unicoder(inString):
#   newString = ""
#   for c in graphemes(inString):
#     if not Unicode.isassigned(c[1]):
#       c = Char(transcode(UInt8,string(c[1]))[1])
#     newString = newString * c
#   return newString
#
# Not all strings are the same
# ============================
# s1 = "noël"
# s2 = "noël"
# s1==s2 # False
# len(s1) # 4
# len(s2) # 5
# unicodedata.is_normalized('NFKC',s1) # True
# unicodedata.is_normalized('NFKC',s2) # False
# extract(s1, [s2], scorer=Jaro.normalized_similarity) # [('noël', 0.7833333333333333, 0)]
# s1 == unicodedata.normalize('NFKC',s2) True
# extract(s1, [unicodedata.normalize('NFKC',s2)], scorer=Jaro.normalized_similarity) # [('noël', 1.0, 0)]
# =============================
#
#%% Time stamp file
def timeStamped(fname, fmt='_%Y-%m-%d_%H-%M-%S.'):
    base, ext = fname.split('.')
    return base + datetime.datetime.now().strftime(fmt).format(fname=fname) + ext
#
#%% Parse random scientific name to Genus species Author
# Not necessary for Buster. Everything is upppercase so losing the formatting that helps identify Genus species author
#
# def busterParser(inString):
#   # if !isvalid(inString)
#   #   inString=unicoder(inString)
#   # end
#   #
#   # for a regex and unicode primer see https://www.regular-expressions.info/unicode.html
#   #
#   if not unicodedata.is_normalized('NFKC',inString):
#     inString = unicodedata.normalize('NFKC',inString)
#   if  " x " in inString:  # for hybrid stuff
#     print(inString," => ")
#     inString = inString.replace(" x "," × ") # make all hybrid marks consistent
#     print(inString)
#   inString.lstrip('X') # Some repositories have a leading X just to irk unicorns and programmers
#   sn = inString.split(" ") # Break it up to Genus species Author
#   canName=""
#   p = regex.compile(r"^\p{Lu}(\p{Lu}|\p{Ll}|\-){0,}\p{Ll}$") # Genus should start with a capital letter and end with a lowercase and stuff in between
#   if p.match(sn[0]):
#     # global canName
#     canName = sn[0]
#     parseCount = 1
#     for j in sn[1:]:
#       p = regex.compile(r"^\p{Ll}(\p{Ll}|\-){0,}\p{Ll}$") # specific epithet should start with a lower case
#       q = regex.compile(r"^s{1,2}p{1,2}$|^ex$|^form.$|^x$|^NULL$|^de$",regex.IGNORECASE) # but not include "sp" "spp" "ssp" "ssp" OR "ex" OR form
#       if p.match(j) and not q.match(j) and parseCount < 3:
#         canName = canName + " " + j
#         parseCount = parseCount + 1
#     return str(canName)
#   else:
#     #@show inString, " is not valid"
#     return "helpMe"
#
#%% Define busterize function
def busterize(input):
  genus_species=gsp[input]
  found = False
  Luna[input] = {}
  matched = set()
  alphabetSoup = set(input.split()) #' '.join(genus_species.values())
  # print(alphabetSoup)
  for (k,v) in genus_species.items(): # parse entry by separating the genus and species column
    Luna[input][k+'_input'] = v # recard the genus and species entry
    soupBowl = set(v.split())
    for field in fields:
      matches = soupBowl.intersection(puddles[field])
      if len(matches) > 0:
        # matched += matches
        if field in Luna[input]:
          Luna[input][field].update(matches)
        else:
          Luna[input][field] = matches
        matched.update(matches)
  if len(matched) > 0:
    Luna[input]['matched'] = matched
  if 'family' in Luna[input]:
    alphabetSoup -= Luna[input]['family']
  if 'genus' in Luna[input] and 'species' in Luna[input]: # Create and test permutations of genus and species combinations
    # print(input, 'genus & species found')
    gs = set()
    alphabetSoup -= Luna[input]['genus'] | Luna[input]['species']
    Luna[input]['alphabetSoup'] = alphabetSoup
    for g in Luna[input]['genus']:
      for s in Luna[input]['species']:
        gs.update({g + ' ' + s})
    # print("gs is", gs)
    matches=gs.intersection(taxonName)
    if len(matches) > 0:
      Luna[input].update({"match": matches, "score": .9, 'GiGi': True})
      found = True
    else: # Could be that the canonical name was put in one ot the other entries
      gs = set()
      for i in set(Luna[input]['genus']).union(set(Luna[input]['species'])):
        for j in set(Luna[input]['genus']).union(set(Luna[input]['species'])):
          gs.update(i + ' ' + j)
      matches=gs.intersection(taxonName)
      if len(matches) > 0:
        Luna[input].update({"match": matches, "max_score": .8, 'iGiG': True})
        found = True
  if 'species' in Luna[input] and not found: # missing a genus
    # print(input, 'species found')
    alphabetSoup -= Luna[input]['species']
    Luna[input]['alphabetSoup'] = alphabetSoup
    gs=set()
    if len(alphabetSoup) > 0:
      for soupBowl in alphabetSoup:
        tmp = extract(soupBowl, puddles['genus'],
                      scorer=DamerauLevenshtein.normalized_similarity, limit=10)
        fuzzy = {i[0]:i[1] for i in tmp}
        # print(soupBowl, '\n', fuzzy)
        for i in set(fuzzy.keys()):
          for j in Luna[input]['species']:
            gs.update({i + ' ' + j})
      # print('searching genus', gs)
      matches=gs.intersection(taxonName)
      if len(matches) > 0:
        Luna[input].update({"match": matches, "score": .6, 'busted': True})
        found = True
  if 'genus' in Luna[input] and not found: # missing a species
    # print(input, 'genus found')
    alphabetSoup -= Luna[input]['genus']
    Luna[input]['alphabetSoup'] = alphabetSoup
    gs=set()
    if len(alphabetSoup) > 0:
      for soupBowl in alphabetSoup:
        tmp = extract(soupBowl, list(puddles['species']),
                    scorer=DamerauLevenshtein.normalized_similarity, limit=10)
        fuzzy = {i[0]:i[1] for i in tmp}
        for i in Luna[input]['genus']:
          for j in set(fuzzy.keys()):
            gs.update({i + ' ' + j})
      matches=gs.intersection(taxonName)
      if len(matches) > 0:
        Luna[input].update({"match": matches, "score": .7, 'busted': True})
        found = True
  if len(alphabetSoup) > 0 and not found:
    # print(input, 'nothing found')
    Luna[input]['alphabetSoup'] = alphabetSoup
    gs = set()
    fuzzy = {"genus": set(), "species": set()}
    for k in fuzzy:
      # print(k)
      for soupBowl in alphabetSoup:
        tmp = extract(soupBowl, puddles[k],
                      scorer=DamerauLevenshtein.normalized_similarity, limit=10)
        fuzzy[k] |= set((i[0] for i in tmp))
    for i in fuzzy["genus"]:
      for j in fuzzy["species"]:
        gs.update({i + ' ' + j})
    # print('searching genus', fuzzy, gs)
    matches=gs.intersection(taxonName)
    if len(matches) > 0:
      Luna[input].update({"match": matches, "score": .5, 'busted': True})
      found = True
  if not found:
    Luna[input].update({"match": "No match", "score": .0, 'busted': True})
#
#%% Define global variables
Luna = {}
puddles = {}
#
#%% Define data fields
cols = ['taxon_name','family','genus','species','genus_hybrid','species_hybrid','infraspecies','parenthetical_author','primary_author','infraspecific_rank']
fields = ['family','genus','species','genus_hybrid','species_hybrid','infraspecies','infraspecific_rank', 'authors','vernaculars','webster']
#
#%% Taxonomic reference set import
wcvp = pd.read_csv("/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/WCVP/wcvp_names.csv", delimiter='|',usecols=cols)
# wcvp = pd.read_csv("/home/hermy/LakesideSync/ArborTron/Buster/WCVP/wcvp_names.csv", delimiter='|',usecols=cols)
for i in cols:
  wcvp[i]=wcvp[i].str.upper()
#
#%% Author reference set and clean up to remove duplication
tmp = pd.read_csv('/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/WCVP/wcvp_author.csv', na_filter=False)
# tmp = pd.read_csv('/home/hermy/LakesideSync/ArborTron/Buster/WCVP/wcvp_author.csv', na_filter=False)
tmp = set(tmp.parenthetical_author.str.upper()).union(set(tmp.primary_author.str.upper()))
# tmp = set(tmp[~pd.isna(tmp)])
# tmp = [regex.sub(' +', ' ', i.replace('.', ' ').strip()) for i in tmp]
# authors = [i.translate(str.maketrans('', '', string.punctuation)) for i in authors]
# authors = [i.upper() for i in authors]
tmp.discard("")
#
p = regex.compile(r"\sEX\s|\s&\s|,\s")
#
puddles['authors'] = set()
for i in tmp:
  puddles['authors'].update(strip_accents(j.rstrip(".")) for j in regex.split(p, i))
#
#%% Vernacular reference set
#

puddles['vernaculars'] = set([i.upper() for i in pd.read_csv('/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/WCVP/commonnames_utf8_updated_2019-06-26.csv',usecols=['_common_name_001'])['_common_name_001'] if not pd.isna(i)])
# puddles['vernaculars'] = set([i.upper() for i in pd.read_csv('/home/hermy/LakesideSync/ArborTron/Buster/WCVP/commonnames_utf8_updated_2019-06-26.csv',usecols=['_common_name_001'])['_common_name_001'] if not pd.isna(i)])

#%% American-english dictionary only 102485 entries
#
with open('/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/WCVP/american-english-huge') as wordbook:
# with open('/home/hermy/LakesideSync/ArborTron/Buster/WCVP/american-english-huge') as wordbook:
  puddles['webster'] = set(word.strip().upper() for word in wordbook)

#%% Secial uses
specialUses = set(["SPECIAL COMPOSITE", "SPECIAL COMPOSITE", "SPECIAL SPF", "TEMP AATH", "TEMP LOPM", "SPECIAL RECYCLED", "SPECIAL RECLAIMED", "SPECIAL PREAMENDMENT", "HYBRID"])
#
#%% Set Taxon Names and remove cols
taxonName=set(wcvp['taxon_name'])
cols.remove("taxon_name")
cols.remove("parenthetical_author")
cols.remove("primary_author")
#
for i in cols:
  puddles[i] = set(i.replace('.', ' ').strip() for i in pd.unique(wcvp[i].dropna()))
  print(i, len(puddles[i]))
#
#%% Read Lacey Things Data
# Enter your data here. Buster is expecting a "genus" and "species" column.
woodyTaxaPD = pd.read_csv("/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/OneDrive_2_5-8-2024/speciesyear21to22.csv", sep='\t', encoding='utf-16',usecols=['Genus','Species'], na_filter=False)
woodyTaxaPD = pd.concat([woodyTaxaPD, pd.read_csv("/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/OneDrive_2_5-8-2024/allspecies22to23.csv", sep='\t', encoding='utf-16',usecols=['Genus','Species'], na_filter=False)])
# Syncthing/
woodyTaxaPD = pd.read_csv("/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/OneDrive_2_5-8-2024/allLaceyNames2324.csv", na_filter=False)
gsp = {(i+' '+j).strip():{'genus':i, 'species':j} for (i,j) in zip(woodyTaxaPD['Genus'].str.upper(), woodyTaxaPD['Species'].str.upper())}
gspKeys = set(gsp.keys())
#
#%% Run intersections to rapidly remove excat matches
matches=gspKeys.intersection(specialUses)
Luna = {i:{"match": i, "score": 1} for i in matches}
gspKeys -= matches
matches=gspKeys.intersection(taxonName)
Luna.update({i:{"match": i, "score": 1} for i in matches})
gspKeys -= matches
#
#%% initialize Luna
Luna={}
#%% Parallel process
output = Parallel(n_jobs=-1, require='sharedmem',verbose=1)(delayed(busterize)(k)
                                                            for k in gspKeys)
#%% Write results
df = pd.DataFrame.from_dict(Luna, orient="index")
df.to_csv(timeStamped("/home/hermy/Syncthing/LakesideSync/ArborTron/Buster/ZekeShriek.csv"), sep='|')
#
#%% Align the matches
# leRoi_leRoo = {}
# for i in Luna.keys():
#   if not Luna[i]['max_score'] == 1 and not i in leRoi_leRoo:
#     alignment =  aligner.align(Luna[i]['best_match'], i)[0]
#     print('input:', i, '-> Best match:', Luna[i]['best_match'], '-> with score:', Luna[i]['max_score'])
#     # print(type(alignments))
#     # for alignment in alignments:
#     # alignment.target = alignment.target.replace('$', ' ')
#     # alignment.query = alignment.query.replace('$', ' ')
#     leroi = ['|' if i==j else '.' for i, j in zip(alignment[0], alignment[1])]
#     leRoi_leRoo[i] = leroi
#     print("Reference: ", alignment[0])
#     print("Alignment: ", ''.join(leroi))
#     print("Input:     ", alignment[1])